
#property copyright "*"
#property link      "*"

#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1 Red
#property indicator_color2 DeepSkyBlue
#property indicator_color3 Yellow
#property indicator_color4 Orange
#property indicator_color5 White
//---- input parameters
extern int       iHalfPeriod=14;
extern bool      ShowTrendLines=false;
extern bool      ShowSupResLines=false;
extern bool      ShowFiboLines=false;
extern bool      ShowFiboExpansion=false;
extern bool      ShowFiboFan=false;
extern int       FiboFanType=1;
extern bool      ShowFiboArc=false;
extern int       FiboArcType=1;
extern bool      ShowFiboTime=false;
extern int       FiboTimeType=1;
extern int       Count=5;  
extern int       Shift=0;  

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {

 
//---- indicators
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,159);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexEmptyValue(0,0.0);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,159);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexEmptyValue(1,0.0);
   
   
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexArrow(2,225);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexEmptyValue(2,0.0);
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexArrow(3,226);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexEmptyValue(3,0.0); 
   
   SetIndexStyle(4,DRAW_ARROW);
   SetIndexArrow(4,159);
   SetIndexBuffer(4,ExtMapBuffer5);
   SetIndexEmptyValue(4,0.0);    
     
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    limit=Bars-IndicatorCounted();
   
      for(int i=limit;i>=0;i--){
         ExtMapBuffer1[i]=0;
         ExtMapBuffer2[i]=0;         
         int hb=Highest(NULL,0,MODE_HIGH,iHalfPeriod*2+1,i+1);
         int lb=Lowest(NULL,0,MODE_LOW,iHalfPeriod*2+1,i+1); 
         
            if(hb==i+iHalfPeriod+2){
               ExtMapBuffer1[hb]=High[hb];
                  for(int j=hb+1;j<Bars;j++){
                     if(ExtMapBuffer1[j]!=0){
                        if(ExtMapBuffer1[hb]>ExtMapBuffer1[j]){
                           ExtMapBuffer3[hb]=High[hb]+Point*3;
                        }
                        if(ExtMapBuffer1[hb]<ExtMapBuffer1[j]){
                           ExtMapBuffer4[hb]=High[hb]+Point*3;
                        }  
                        if(ExtMapBuffer1[hb]==ExtMapBuffer1[j]){
                           ExtMapBuffer5[hb]=High[hb]+Point*3;
                        }  
                        break;
                     }
                  }
            }
            if(lb==i+iHalfPeriod+2){
               ExtMapBuffer2[lb]=Low[lb];
                  for(j=lb+1;j<Bars;j++){
                     if(ExtMapBuffer2[j]!=0){
                        if(ExtMapBuffer2[lb]>ExtMapBuffer2[j]){
                           ExtMapBuffer3[lb]=Low[lb]-Point*3;
                        }
                        if(ExtMapBuffer2[lb]<ExtMapBuffer2[j]){
                           ExtMapBuffer4[lb]=Low[lb]-Point*3;
                        }  
                        if(ExtMapBuffer2[lb]==ExtMapBuffer2[j]){
                           ExtMapBuffer5[lb]=Low[lb]-Point*3;
                        }     
                        break;
                     }
                  }               
            }            
      }

   return(0);
  }
//+------------------------------------------------------------------+